/*
Разработка - Шевченко Илья, OaSys, г. Харьков, Украина
Заказчик и идея - Юрий, ai-systems

 The sript consists of two modules: aimp_main and aimp
 
 * aimp - describes a function object "aimp". Constructor must contain "server" parameter in format IP:port
  aimp gives public methods:
   Play()   - starts to play current song. It is better to use Pause
   Pause()  - toggles Play-Pause state. Also starts playing after "Stop"
   Prev()
   Next()
   
   SetPlayPosition(position) 
   Volume(value)
   Mute              - toggles muting state
   RepeatTrack(value)      - false to set off
   RepeatPlaylist(value)   //[0,1,2] "Jump to the next playlist"/"Repeat playlist"/"Stand by"
   Shuffle()         - toggles shuffle
   
   SetCoverSize(size) - size in format "WxH"
   
   RefreshPlaylists() - acks for refreshing playlists list
   SelectPlaylist(id) - acks tracklist for playlist with id
   SelectTrack(playlist_id, track_id) - selects 
   
   Send(method, params, callback) - sending some request to players RPC 
   
 * aimp_main - describes gui object with player and interface settings 
            and so well create "player" object ("aimp" type)
            and adds musthave feedback functions
            
  player aimp calls feedback functions if they exists
     these functions get an "feedback" object. 
     how to work with that objects can see in code in that script
   
  possible functions are:
      FeedbackMode(feedback)
      
      FeedbackMute(feedback)
      FeedbackVolume(feedback)
      FeedbackRepeat(feedback)
      FeedbackShuffle(feedback)
      
      FeedbackTrackInfo(feedback)
      FeedbackTrackCover(feedback)  
      FeedbackTrackPosition(feedback) 
      
      FeedbackPlaylistCurrent(feedback)
      FeedbackTrackCurrent(feedback)
      
      FeedbackPlaylists(feedback)
      FeedbackTracklist(feedback)           
   
*/

/******************************************************************************/
// Прячем кнопки со страницы "Str". При добавлении в свой проект без этой страницы, эти строки можно удалить
IR.AddListener(IR.EVENT_ITEM_SHOW,IR.GetItem("Musik"),function()
{
  IR.GetItem("Str").GetItem("knopka").GetState(0).Opacity = 0;
  IR.GetItem("Str").GetItem("knopka 2").GetState(0).Opacity = 0;
});
/******************************************************************************/


var gui = {
   server : "127.0.0.1:3333",
   
   playlists :  IR.GetItem("Musik").GetItem("PlaylistsList"),
   playlist :   IR.GetItem("Musik").GetItem("PlayList"),                  
   playlistname: IR.GetItem("Musik").GetItem("CurrentPlaylistName"),
   playlistheader: IR.GetItem("Musik").GetItem("Item 85"),
   
   playlistnameCountPre: " ( ",
   playlistnameCountPost: " )",
   
   playlistsColCurrent:  0x804000FF,
   playlistsColChoosen:  0x0080C0FF,
   playlistsCol:         0x00000000,
   
   playlistColCurrent: 0xFFD595FF,
   playlistCol:        0xFF000000,
   
   playlistSep:      ". ",
   
   
   newplaylist:  IR.GetItem("Musik").GetItem("New"),
   addplaylist:  IR.GetItem("Musik").GetItem("Add"),
   openplaylist:  IR.GetItem("Musik").GetItem("Open"),
   
   defaultcover: "popup17_item19_state0_image_07DE031A0C362E1A3.png",
   coversize: "560x460",
   cover:   IR.GetItem("Musik").GetItem("Cover"),
   track:   IR.GetItem("Musik").GetItem("Track"),
   album:  IR.GetItem("Musik").GetItem("Album"),
   artist: IR.GetItem("Musik").GetItem("Artist"),
   
   timeline: IR.GetItem("Musik").GetItem("TimeLine 1"),
   timeleft: IR.GetItem("Musik").GetItem("TimeLeft"),
   timeright: IR.GetItem("Musik").GetItem("TimeRight"),
   
   prev:    IR.GetItem("Musik").GetItem("Prev"),
   play:    IR.GetItem("Musik").GetItem("Play"),
   next:    IR.GetItem("Musik").GetItem("Next"),
   
   percent:  IR.GetItem("Musik").GetItem("Percent"),
   volume:    IR.GetItem("Musik").GetItem("Volume"),
   mute:      IR.GetItem("Musik").GetItem("Mute"),
   volumeup:   IR.GetItem("Musik").GetItem("Plus"),
   volumedown:  IR.GetItem("Musik").GetItem("Minus"),
   
   shuffle:     IR.GetItem("Musik").GetItem("Shuffle"),
   repeat:      IR.GetItem("Musik").GetItem("Repeat"),     
   
   repeatAllText: "All"

} ;

//---------------------------------------------------------
// Действия при старте
//---------------------------------------------------------
IR.AddListener(IR.EVENT_START, 0, function() {

   // Создаем объект управления
   var player = new aimp(gui.server);	
    
   var TrackPosition = 0;    //позиция пригрывания
   var TrackLength = 0;      //длина трека                      
   var RepeatMode = 0;       //режим повтора (необходим, т.к. в плеере разделены режим повтора трека и режим повтора плейлиста)
   
   var Time = new Date();     //для отображения позиции и времени трека
   
   var Playlists = [];       //список идентификаторов плейлистов
   var Tracklist = [];       //список идентификаторов треков
   
   var PlaylistCurrentId = 0;   //текущий проигрываемый плейлист
   var PlaylistChoosenId = 0;   //выбранный плейлист
   var TrackCurrentId = 0;       //проигрываемый трек
 
   
   player.SetCoverSize(gui.coversize);        //установить размер запрашиваемой картинки
   
   //=======================================================
   //Добавим слушателей в интерфейс
   //=======================================================

   IR.AddListener(IR.EVENT_ITEM_RELEASE, gui.prev, player.Prev);    //Кнопка предыдущий трек

   IR.AddListener(IR.EVENT_ITEM_RELEASE, gui.next, player.Next);    //кнопка следующий трек

   IR.AddListener(IR.EVENT_ITEM_RELEASE, gui.play, player.Pause);   
   
   
   IR.AddListener(IR.EVENT_ITEM_RELEASE, gui.timeline, function() {
   
      player.SetPlayPosition(gui.timeline.Value * TrackLength / 100);
   }); 
   
   
   
   IR.AddListener(IR.EVENT_ITEM_RELEASE, gui.volume, function() {
   
     player.Volume(gui.volume.Value);
   }); 
   
   
   IR.AddListener(IR.EVENT_ITEM_PRESS, gui.mute, player.Mute);
   IR.AddListener(IR.EVENT_ITEM_PRESS, gui.shuffle, player.Shuffle);  
     
   IR.AddListener(IR.EVENT_ITEM_RELEASE, gui.volumeup, function() {

     player.Volume(gui.volumeup.Value);
   });
   
   
   IR.AddListener(IR.EVENT_ITEM_RELEASE, gui.volumedown, function() {
   
     player.Volume(gui.volumedown.Value);
   });
   
   
   IR.AddListener(IR.EVENT_ITEM_RELEASE, gui.repeat, function() {
     RepeatMode = (++RepeatMode == 3) ? 0: RepeatMode;
        //у AIMP отдельная тема - повтор трека и отдельная плейлиста.
        //поэтому лепим из двух одно
     switch (RepeatMode) {
      case 0:
       player.RepeatTrack(0);
       player.RepeatPlaylist(0);
      break;
      
      case 1:
       player.RepeatTrack(1);
       player.RepeatPlaylist(0);
      break;
      
      case 2:
       player.RepeatTrack(0);
       player.RepeatPlaylist(1);
      break;
     }
     
   });
   
                                                  //выбор плейлиста
   IR.AddListener(IR.EVENT_ITEM_SELECT, gui.playlists, function(Item, Subitem){
        
     player.SelectPlaylist(Playlists[Item].id);   
     PlaylistsSet(null,Playlists[Item].id);   
   });
   
                                                 //выбор трека
   IR.AddListener(IR.EVENT_ITEM_SELECT, gui.playlist, function(Item, Subitem) {
   
     player.SelectTrack(   //в начале список не выбран и отображается текущий проигрываемый - из него и производится выбор
                        ((PlaylistChoosenId > 0) ? PlaylistChoosenId : PlaylistCurrentId)   
                        , Tracklist[Item]);   
   });      
      
   
   IR.AddListener(IR.EVENT_ITEM_HOLD, gui.playlistname, player.RefreshPlaylists); //ручное обновление списка плейлистов
   IR.AddListener(IR.EVENT_ITEM_RELEASE, gui.playlistheader, player.RefreshPlaylists); //ручное обновление списка плейлистов
   
    //=======================================================
    //Добавим обработчиков обратной связи в плеер
    //=======================================================
   player.FeedbackMute = function (feedback) {
   
    if ("mute_mode_on" in feedback)  gui.mute.Value = +feedback["mute_mode_on"];     //обратная связь статуса
    else if ("mute_on" in feedback)  gui.mute.Value = +feedback["mute_on"];          //обратная связь сообщения Mute
   };                                  
   
   
   player.FeedbackVolume = function (feedback){
   
     if ("volume" in feedback)  
     gui.volumeup.Value = gui.volume.Value = feedback["volume"];
   };
   
   
   player.FeedbackRepeat = function (feedback){
   
     RepeatMode = 0;
     
     if ("repeat_mode_on" in feedback) 
            //если включен повтор трека, то повтор плейлиста не важен - будет повторяться трек
       if (feedback["repeat_mode_on"]) RepeatMode = 1;      
       else
        if ("repeat_playlist_mode" in feedback)
         if (feedback["repeat_playlist_mode"] == 1) RepeatMode = 2;       
                        //[0,1,2] "Jump to the next playlist"/"Repeat playlist"/"Stand by"
                        
     switch (RepeatMode){
      case 0:                    //нет повтора
         gui.repeat.Value = 0;  
      break;
      
      case 1:                    //повтор трека
         gui.repeat.Value = 1;
         gui.repeat.GetState(1).Text = "";
      break;
     
      case 2:                    //повтор плейлиста
         gui.repeat.Value = 1;
         gui.repeat.GetState(1).Text = gui.repeatAllText;       
      break;
     }
     
   };

   
   player.FeedbackShuffle = function (feedback) {
   
     if ("shuffle_mode_on" in feedback)  gui.shuffle.Value = +feedback["shuffle_mode_on"];
   };
   
   
   player.FeedbackMode = function (feedback) {
   
     if ("playback_state" in feedback)  
         gui.play.Value = (feedback["playback_state"] == "playing") ? 1:0;   //"stopped"    "playing"    "paused"
   };
   
   
   player.FeedbackTrackPosition = function (feedback) {
   
     if ("track_length" in feedback)    TrackLength   = feedback["track_length"];
     if ("value" in feedback)           TrackPosition = feedback["value"];
     if ("track_position" in feedback)  TrackPosition = feedback["track_position"];
   };
   
   
   player.FeedbackTrackInfo = function (feedback) {
   
     if ("album" in feedback)  gui.album.Text  = feedback["album"];
     if ("artist" in feedback) gui.artist.Text = feedback["artist"];
     if ("title" in feedback)  gui.track.Text  = feedback["title"];
   };
   
   
   player.FeedbackTrackCover = function (feedback) {
     
     if ("album_cover_uri" in feedback) 
          gui.cover.GetState(0).Image  = "http://" + gui.server + "/" + feedback["album_cover_uri"];
     else gui.cover.GetState(0).Image  = gui.defaultcover;  
     //если картинка не найдена, то AIMP шлет ERROR вместо album_cover_uri
   };

   
   
  //====================ТРЕКЛИСТ================================ 
   
   player.FeedbackTracklist = function (feedback) {
     
    var i = ("listStartPosition" in feedback)? (feedback["listStartPosition"] - 1) : -1;
    
    if (i == -1) {
      gui.playlist.Clear();
      Tracklist.length = 0;
    }
    
    var item = {};
    
    while((item = feedback["entries"].shift()))
    {
    
      if (item.length != 6) continue;  //количество полей объекта = 6
       Tracklist[++i] = item[0];   
                                       //делаем с нумерацией позиций треклиста
       gui.playlist.CreateItem(i, 2, {Text: (i + 1) + gui.playlistSep + item[1]});
       gui.playlist.CreateItem(i, 3, {Text: item[2]});
       gui.playlist.CreateItem(i, 4, {Text: item[3]});
       gui.playlist.CreateItem(i, 5, {Text: item[4]});
       
       Time.setTime(item[5]);  //Содрано у иридия - возможно есть реализация получше
       gui.playlist.CreateItem(i, 8, {
                                      Text: ((Time.getUTCHours()   > 0)?(Time.getUTCHours() + ":"):"") 
                                          + ((Time.getUTCMinutes() < 10) ? "0" : "") 
                                          +   Time.getUTCMinutes() 
                                          + ((Time.getUTCSeconds() < 10) ? ":0" : ":") 
                                          +   Time.getUTCSeconds()
                                     });
       
    } 
     
     if (feedback["count_of_found_entries"] != gui.playlist.ItemsCount)  return;      
     //выводим количество и устанавливаем текущий только по завершении формирования треклиста
     
     gui.playlistname.Text = gui.playlistname.Text 
                           + gui.playlistnameCountPre + gui.playlist.ItemsCount + gui.playlistnameCountPost;
                           
     SetCurrentTrack();
   };
   
   
   
   player.FeedbackTrackCurrent = function(feedback) {
           
    if ("track_id" in feedback) SetCurrentTrack(feedback["track_id"]);
   } 
     
   
   function SetCurrentTrack(current) {

     function SetColor(id,color) {
     
      if (id > 0)
       for (var i = 0; i < Tracklist.length ; ++i)
          if (Tracklist[i] == id) {
          
           var tr = gui.playlist.CreateItem(i,1,{FillColor: color});
           return tr;
          }
          
        return -1;  
     }   
      
      if (current != null) {
       
        SetColor(TrackCurrentId, gui.playlistCol);
        TrackCurrentId = current;                        
       }
       
       SetColor(TrackCurrentId, gui.playlistColCurrent); 
      

   }
   
   
  //====================СПИСОК ПЛЕЙЛИСТОВ================================   
  
   player.FeedbackPlaylists = function (feedback) {
   
    var i = -1;
    
    Playlists.length = 0;
    gui.playlists.Clear();
    var item = {};
    
     while(item = feedback.shift()) {
    
      if (!("id" in item)) continue;
     
       Playlists[++i] = {id: item.id, title: item.title};       
       gui.playlists.CreateItem(i, 1, {Text: item["title"]});         
     }
    
    PlaylistsSet();    
   };
   
   
   
   player.FeedbackPlaylistCurrent = function(feedback) {
          
     if("playlist_id" in feedback) PlaylistsSet(feedback["playlist_id"]);       
   }     
     
   function PlaylistsSet(current, choosen) {
   
     function SetColor(id, color) {
             
      if (id != 0 )      
       for (var i = 0; i < Playlists.length ; ++i)
        if (Playlists[i].id == id) {
         
          gui.playlists.CreateItem(i, 0, {FillColor: color});
          return i;
         }
     }
              
      if (choosen > 0) 
      //Если выбирается новый плейлист в списке - выделяем его
      //если необходимо выделяем проигрываемый
      //если необходимо снимаем выделение старого выбранного   
      //сохраняем выбранный 
      {
       if (choosen != PlaylistChoosenId)
       {
                                                                                           //установим заодно имя
        gui.playlistname.Text = Playlists[SetColor(choosen, gui.playlistsColChoosen)].title;
                
   
        if (PlaylistChoosenId == PlaylistCurrentId)          //Если раньше выбранный был и проигрываемым, то сейчас надо выделить проигрываемый
         SetColor(PlaylistCurrentId, gui.playlistsColCurrent);
        else
         SetColor(PlaylistChoosenId, gui.playlistsCol);       //в противном случае необходимо снять пометку с ранее выбранного
       
        PlaylistChoosenId = choosen;
        
       }   
      }
      else if (current > 0) {
      //если меняется проигрываемый
      //если проигрываемый отличается от выбранного - помечаем
      //если ранее проигрываемый отличался от выбранного - снимаем пометку                                                      +
      //сохраняем проигрываемый
      
        if (PlaylistCurrentId != PlaylistChoosenId) SetColor(PlaylistCurrentId, gui.playlistsCol);    
        if (current !=  PlaylistChoosenId)  var currentname = SetColor(current, gui.playlistsColCurrent);
        
        if (PlaylistChoosenId == 0) { 
         
          gui.playlistname.Text = Playlists[currentname].title;
          player.SelectPlaylist(-1);
         } 
         
         PlaylistCurrentId = current;  
        
      }
      
      else if (PlaylistCurrentId > 0) {
       //отметка стоит выполнения только если уже есть значение проигрываемого.
       //Если его нет - он скоро придет и процедура выполнится повторно
       //выбранный помечается в любом случае
       //проигрываемый  помечается только если не равен выбранному 
      
        SetColor(PlaylistChoosenId,gui.playlistsColChoosen);
        if(PlaylistCurrentId != PlaylistChoosenId) SetColor(PlaylistCurrentId, gui.playlistsColCurrent);
      }

   };

             //таймлайн - автномно при проигрывании. Обратная связь от плеера корректирует таймлайн через значение.
   
   IR.SetInterval(1000, function() {
   
    if (!gui.play.Value) return;
    
     TrackPosition += 1;
     gui.timeline.Value = TrackPosition * 100 / TrackLength;
     
     Time.setTime((TrackLength - TrackPosition)*1000);
     gui.timeleft.Text = "" + Time.getUTCHours() 
                          + ((Time.getUTCMinutes() < 10) ? ":0" : ":") 
                          +   Time.getUTCMinutes() 
                          + ((Time.getUTCSeconds() < 10) ? ":0" : ":") 
                          +   Time.getUTCSeconds();
     
     Time.setTime(TrackPosition*1000);
     gui.timeright.Text = "" +   Time.getUTCHours() 
                             + ((Time.getUTCMinutes() < 10) ? ":0" : ":") 
                             +   Time.getUTCMinutes() 
                             + ((Time.getUTCSeconds() < 10) ? ":0" : ":") 
                             +   Time.getUTCSeconds();

   });
   
      
   
});

